﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="WebForm3.aspx.vb" Inherits="WebApplication1.WebForm3" %>

<%@ Register Assembly="Infragistics45.Web.v14.1, Version=14.1.20141.2011, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script type="text/javascript">
        var _DDL_Entity_Multiple_Address_DropDownProvider;
        function DDL_Entity_Multiple_Address_Initialize(sender, e) {
            _DDL_Entity_Multiple_Address_DropDownProvider = sender;
        }

        function UG_AddressforBill_CellEditing_EnteredEditMode(sender, eventArgs) {
            var cell = eventArgs.getCell();
            var value = eventArgs.getCell().get_row().get_cellByColumnKey("Entity_Name").get_value();
            if (cell.get_column().get_key() == "Entity_Multiple_Address_ID") {
                _DDL_Entity_Multiple_Address_DropDownProvider.loadItems(value);
            }
        }

        function DropDownProvider_Opening(sender, eventArgs) {
            sender._elements.DropDownContents.style.cssText = "overflow:auto; width:" + sender._element.clientWidth + "px;height:auto; max-height:160px;";    // height:160px;
        }

        var cellText;
        function DDL_Action_Type_SelectionChanged(sender, eventArgs) {
            var item = eventArgs.getNewSelection()[0];
            var row = ig_controls.UG_AddressforBill.get_behaviors().get_activation().get_activeCell().get_row();
            if (row != null) {
                row.get_cellByColumnKey("Action").set_value(item.get_value());
                cellText = item.get_text();
            }
        }

        function DDL_Entity_Name_SelectionChanged(sender, eventArgs) {
            var item = eventArgs.getNewSelection()[0];
            var row = ig_controls.UG_AddressforBill.get_behaviors().get_activation().get_activeCell().get_row();

            if (row != null) {
                row.get_cellByColumnKey("Entity_Name").set_value(item.get_value());
                cellText = item.get_text();
                row.get_cellByColumnKey("Entity_Multiple_Address_ID").set_value(null);
                row.get_cellByColumnKey("Entity_Multiple_Address_ID").set_text("");
            }
        }

        function DDL_Entity_Multiple_Address_SelectionChanged(sender, eventArgs) {
            var item = eventArgs.getNewSelection()[0];
            var row = ig_controls.UG_AddressforBill.get_behaviors().get_activation().get_activeCell().get_row();

            if (row != null) {
                row.get_cellByColumnKey("Entity_Address").set_value(item.get_value());
                cellText = item.get_text();
            }
        }

        function UG_AddressforBill_CellEditing_EnteringEditMode(sender, eventArgs) {
            var cell = eventArgs.getCell();
            var row = cell.get_row();
            var key = cell.get_column().get_key();

            if (cell.get_element().className.indexOf("ReadOnly") >= 0) {
                eventArgs.set_cancel(true);
                return;
            }

            if (key == "SRVC_ledger_Billing_Address_Action_Type_Lkup_ID") {
                cellText = cell.get_text();
                cell.set_value(row.get_cellByColumnKey("Action").get_value());
            }

            if (key == "Entity_ID") {
                cellText = cell.get_text();
                cell.set_value(row.get_cellByColumnKey("Entity_Name").get_value());
            }
        }

        function UG_AddressforBill_CellEditing_EnteredEditMode(sender, eventArgs) {
            var cell = eventArgs.getCell();
            var value = eventArgs.getCell().get_row().get_cellByColumnKey("Entity_Name").get_value();
            if (cell.get_column().get_key() == "Entity_Multiple_Address_ID") {
                //RemoveInsertRowNull("UG_AddressforBill");
                _DDL_Entity_Multiple_Address_DropDownProvider.loadItems(value);
            }
        }

        function UG_AddressforBill_CellEditing_ExitedEditMode(sender, eventArgs) {
            var cell = eventArgs._cell;
            var row = cell.get_row();
            var key = cell.get_column().get_key();

            if (key == "SRVC_ledger_Billing_Address_Action_Type_Lkup_ID" || key == "Entity_ID") {
                cell.set_text(cellText);
            }

            //# AddNewRow
            if (row.get_index() == sender.get_rows().get_length() - 1) {
                AddNewRow(sender._id);
                //re active cell
                //setTimeout(function () {
                //    sender.get_behaviors().get_activation().set_activeCell(cellActive);
                //    sender.get_behaviors().get_editingCore().get_behaviors().get_cellEditing().enterEditMode(cellActive);
                //}, 300);
            }
        }

        function RemoveInsertRowNull(gridName) {
            var grid = $find(gridName);
            if (grid != null) {
                for (var j = grid.get_rows().get_length() - 1; j >= 0 ; j--) {
                    var bRemove = true;
                    var row = grid.get_rows().get_row(j);
                    if (row.get_cellByColumnKey("ID").get_value() > 0) {
                        return;
                    }
                    var columns = grid.get_columns();
                    for (var i = 0; i < columns.get_length() ; i++) {
                        if (!columns.get_column(i).get_hidden()) {
                            switch (columns.get_column(i).get_type()) {
                                case "number":
                                    if (row.get_cellByColumnKey(columns.get_column(i).get_key()).get_value() > 0) {
                                        bRemove = false;
                                    }
                                    break;
                                case "boolean":
                                    if (row.get_cellByColumnKey(columns.get_column(i).get_key()).get_value() != false) {
                                        bRemove = false;
                                    }
                                    break;
                                case "date":
                                    if (row.get_cellByColumnKey(columns.get_column(i).get_key()).get_value() != null) {
                                        bRemove = false;
                                    }
                                    break;
                                case "string":
                                    if (row.get_cellByColumnKey(columns.get_column(i).get_key()).get_value() != null) {
                                        bRemove = false;
                                    }
                                    break;
                                default:
                                    break;
                            }
                        }
                    }
                    if (bRemove) {
                        grid.get_behaviors().get_editingCore().undoBatchUpdate(row);
                    }
                }
            }
        }

        function AddNewRow(gridName) {
            var grid = window.$find(gridName);
            if (grid != null) {
                if (grid.get_columns().get_length() > 0) {
                    var row = new Array();
                    for (var i = 0; i < grid.get_columns().get_length() ; i++) {
                        var column = grid.get_columns().get_column(i);
                        switch (column._type) {
                            case "number":
                                if (column._key == "ID") row.push(-1 * grid.get_rows().get_length());
                                else row.push(null);
                                break;
                            case "boolean":
                                row.push(false); break;
                            case "date":
                                row.push(null); break;
                            case "string":
                                if (column._key == "Status") {
                                    row.push("");
                                } else row.push(null);
                                break;
                            default: break;
                        }
                    }
                    grid.get_rows().add(row);

                    if (gridName == 'UG_FeeSchedules') {
                        grid.get_rows().get_row(grid.get_rows().get_length() - 1).get_cellByColumnKey("Amount").get_element().className = "ReadOnlyTextRight";
                        grid.get_rows().get_row(grid.get_rows().get_length() - 1).get_cellByColumnKey("Effective_Dt").get_element().className = "ReadOnlyTextLeft";
                    }
                }
            }
        }

        function UG_AddressforBill_RowAdding_EnteredEditMode(sender, eventArgs) {
            var cell = eventArgs.getCell();
            var value = eventArgs.getCell().get_row().get_cellByColumnKey("Entity_Name").get_value();
            if (cell.get_column().get_key() == "Entity_Multiple_Address_ID") {
                _DDL_Entity_Multiple_Address_DropDownProvider.loadItems(value);
            }
        }

        function UG_AddressforBill_Editing_RowAdding(sender, eventArgs) {
            // eventArgs.get_row().get_cell(0).set_value(sender.get_rows().get_length() * -1);
        }
    </script>
</head>
<body>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
        <div>
            <asp:UpdatePanel ID="UpdatePanel1" runat="server" UpdateMode="Conditional">
                <ContentTemplate>
                    <ig:WebDataGrid ID="UG_AddressforBill" runat="server" Width="100%" AutoGenerateColumns="False" EnableDataViewState="True" DataKeyFields="ID"
                        EnableAjax="True" Font-Bold="False" TabIndex="117">
                        <Columns>
                            <ig:BoundDataField DataFieldName="ID" Hidden="True" Key="ID">
                            </ig:BoundDataField>
                            <ig:BoundCheckBoxField DataFieldName="ACTIVE_YN" Key="Active_YN" CssClass="NormalTextCenter" Width="10%">
                                <CheckBox CheckedImageUrl="~/ig_res/Default/images/ig_checkbox_on.gif"
                                    PartialImageUrl="~/ig_res/Default/images/ig_checkbox_partial.gif"
                                    UncheckedImageUrl="~/ig_res/Default/images/ig_checkbox_off.gif" />
                                <Header Text="Active" CssClass="NormalTextCenter"></Header>
                                <Footer CssClass="NormalTextCenter"></Footer>
                            </ig:BoundCheckBoxField>
                            <ig:BoundDataField DataFieldName="SRVC_LEDGER_BILLING_ADDRESS_ACTION_TYPE_LKUP_ID" Key="SRVC_ledger_Billing_Address_Action_Type_Lkup_ID"
                                Width="17%" CssClass="NormalTextLeft">
                                <Header Text="Action" CssClass="NormalTextCenter"></Header>
                                <Footer CssClass="NormalTextCenter"></Footer>
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="ENTITY_ID" Key="Entity_ID" Width="20%" CssClass="NormalTextLeft">
                                <Header Text="Entity Name" CssClass="NormalTextCenter"></Header>
                                <Footer CssClass="NormalTextCenter"></Footer>
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="ENTITY_MULTIPLE_ADDRESS_ID" Key="Entity_Multiple_Address_ID" Width="33%" CssClass="NormalTextLeft">
                                <Header Text="Address" CssClass="NormalTextCenter"></Header>
                                <Footer CssClass="NormalTextCenter"></Footer>
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="START_DT" Key="Start_Dt" Width="10%" CssClass="NormalTextLeft" DataType="Syste.DateTime">
                                <Header Text="Begin Date" CssClass="NormalTextCenter"></Header>
                                <Footer CssClass="NormalTextCenter"></Footer>
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="Stop_Dt" Key="Stop_Dt" Width="10%" CssClass="NormalTextLeft" DataType="Syste.DateTime">
                                <Header Text="End Date" CssClass="NormalTextCenter"></Header>
                                <Footer CssClass="NormalTextCenter"></Footer>
                            </ig:BoundDataField>
                            <ig:UnboundField Hidden="True" Key="Status" />
                            <ig:BoundDataField DataFieldName="SRVC_ledger_Billing_Address_Action_Type_Lkup_ID" Hidden="True" Key="Action">
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="Entity_ID" Hidden="True" Key="Entity_Name">
                            </ig:BoundDataField>
                            <ig:BoundDataField DataFieldName="Entity_Multiple_Address_ID" Hidden="True" Key="Entity_Address">
                            </ig:BoundDataField>
                        </Columns>
                        <EditorProviders>
                            <ig:DropDownProvider ID="Payment_SRVC_ledger_Billing_Address_Action_Provider" StretchHeight="False">
                                <EditorControl runat="server" DropDownContainerMaxHeight="160px" EnableAnimations="False"
                                    DisplayMode="DropDownList" NullText="null" DropDownContainerHeight="160px">
                                    <ClientEvents DropDownOpening="DropDownProvider_Opening" SelectionChanged="DDL_Action_Type_SelectionChanged" />
                                </EditorControl>
                            </ig:DropDownProvider>
                            <ig:DropDownProvider ID="Payment_Entity_Provider" StretchHeight="False">
                                <EditorControl runat="server" DropDownContainerMaxHeight="160px" EnableAnimations="False"
                                    DisplayMode="DropDownList" NullText="null" DropDownContainerHeight="160px">
                                    <ClientEvents DropDownOpening="DropDownProvider_Opening" SelectionChanged="DDL_Entity_Name_SelectionChanged" />
                                </EditorControl>
                            </ig:DropDownProvider>
                            <ig:DropDownProvider ID="Payment_Entity_Multiple_Address_Provider" StretchHeight="False">
                                <EditorControl runat="server" ClientIDMode="Predictable" DropDownContainerMaxHeight="160px"
                                    EnableAnimations="False" EnableViewState="True" NullText="null"
                                    EnableDropDownAsChild="False" DataKeyFields="ID"
                                    OnItemsRequested="DDL_Entity_Multiple_Address_ItemsRequested">
                                    <ClientEvents DropDownOpening="DropDownProvider_Opening" Initialize="DDL_Entity_Multiple_Address_Initialize"
                                        SelectionChanged="DDL_Entity_Multiple_Address_SelectionChanged" />
                                </EditorControl>
                            </ig:DropDownProvider>
                            <ig:DatePickerProvider ID="UG_AddressforBill_DatePickerProvider1">
                                <EditorControl ClientIDMode="Predictable">
                                </EditorControl>
                            </ig:DatePickerProvider>
                            <ig:DatePickerProvider ID="UG_AddressforBill_DatePickerProvider2">
                                <EditorControl ClientIDMode="Predictable">
                                </EditorControl>
                            </ig:DatePickerProvider>
                        </EditorProviders>
                        <Behaviors>
                            <ig:EditingCore BatchUpdating="True" AutoCRUD="True">
                                <EditingClientEvents RowAdding="UG_AddressforBill_Editing_RowAdding" />
                                <Behaviors>
                                    <ig:CellEditing EditCellCssClass="NormalText" Enabled="true">
                                        <ColumnSettings>
                                            <ig:EditingColumnSetting ColumnKey="SRVC_ledger_Billing_Address_Action_Type_Lkup_ID" EditorID="Payment_SRVC_ledger_Billing_Address_Action_Provider" />
                                            <ig:EditingColumnSetting ColumnKey="Entity_ID" EditorID="Payment_Entity_Provider" />
                                            <ig:EditingColumnSetting ColumnKey="Entity_Multiple_Address_ID" EditorID="Payment_Entity_Multiple_Address_Provider" />
                                            <%--                                  <ig:EditingColumnSetting ColumnKey="Start_Dt" EditorID="UG_AddressforBill_DatePickerProvider1" />
                                    <ig:EditingColumnSetting ColumnKey="Stop_Dt" EditorID="UG_AddressforBill_DatePickerProvider2" />--%>
                                        </ColumnSettings>
                                        <EditModeActions EnableOnActive="True" MouseClick="Single" />
                                        <CellEditingClientEvents EnteringEditMode="UG_AddressforBill_CellEditing_EnteringEditMode"
                                            ExitedEditMode="UG_AddressforBill_CellEditing_ExitedEditMode"
                                            EnteredEditMode="UG_AddressforBill_CellEditing_EnteredEditMode" />
                                    </ig:CellEditing>
                                    <ig:RowDeleting />
                                </Behaviors>
                            </ig:EditingCore>
                            <ig:Sorting Enabled="true">
                            </ig:Sorting>
                            <ig:Activation Enabled="true" />
                            <ig:Selection CellClickAction="Row" RowSelectType="Single" Enabled="true">
                            </ig:Selection>
                            <ig:RowSelectors Enabled="True" RowNumbering="False" EnableInheritance="True">
                            </ig:RowSelectors>
                            <ig:Paging PagerAppearance="Bottom" PageSize="16" Enabled="false" QuickPages="9" />
                        </Behaviors>
                    </ig:WebDataGrid>
                </ContentTemplate>
                <Triggers>
                    <asp:AsyncPostBackTrigger ControlID="BT_Submit" EventName="Click" />
                </Triggers>
            </asp:UpdatePanel>
        </div>
        <div>
            <asp:Button runat="server" Width="55px" Text="Submit" ID="BT_Submit" OnClientClick="RemoveInsertRowNull('UG_AddressforBill');" />
        </div>
    </form>
</body>
</html>
